#include "setmodelindicatordlg.h"
#include "ui_setmodelindicatordlg.h"
#include "mainwindow.h"
#include "logmodel.h"

#include <QString>

SetModelIndicatorDlg::SetModelIndicatorDlg(db *database, QWidget *parent) : QDialog(parent), ui(new Ui::SetModelIndicatorDlg) {
    ui->setupUi(this);

    for (int i=48; i<58; ++i){
        ui->comboBox->addItem(QString("%1").arg((char)i));
    }
    int i=32;
    ui->comboBox->addItem(QString("%1").arg((char)i));
    for (int i=65; i<91; ++i){
        ui->comboBox->addItem(QString("%1").arg((char)i));
    }
    for (int i=97; i<123; ++i){
        ui->comboBox->addItem(QString("%1").arg((char)i));
    }

    DataBase=database;

    connect( ui->pushButton_Cancel, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( ui->pushButton_OK, SIGNAL( clicked() ), this, SLOT( SetModelIndicatorDlg_OK() ) );

}

SetModelIndicatorDlg::~SetModelIndicatorDlg() {
    delete ui;
}

void SetModelIndicatorDlg::SetModelIndicatorDlg_OK() {

    char status;
    QChar ModelIndicator;
    int ComboIndex=ui->comboBox->currentIndex();

    // 0 to 9
    int ComboChar=ComboIndex+48;
    // space
    if (ComboIndex==10)
        ComboChar=32;
    // A to Z
    if (ComboIndex>=11 && ComboIndex<=36)
        ComboChar=ComboIndex+65-11;
    // a to z
    if (ComboIndex>=37 && ComboIndex<=62)
        ComboChar=ComboIndex+97-37;

    ModelIndicator=(char)ComboChar;

    int NumEvents = DataBase->GetNumberOfEvents();
    event_node_ *Node;

    // This may take some time. Show the wait cursor.
    QApplication::setOverrideCursor(Qt::WaitCursor);

    // Change model indicator for all events.
    for (int i=0; i<NumEvents; ++i){
        Node = DataBase->GetEventByIndex(i);
        Node->hypocenters.first->model=ModelIndicator.toAscii();
        if (!DataBase->UpdateSfile(i, &status)) {
           // Unable to write new event file.
           // Write error message to the log.
           Message = "Failed to update model indicator for '";
           Message.append(Node->metadata.sfile); Message.append("'.");
           emit WriteLog(logmodel::error, Message);
        }
    }

    // Restore the cursor.
    QApplication::restoreOverrideCursor();

    // Close the dialg box.
    accept();
}

